/***************************************************************************
*                 _                                _                       *
*                /_\         Chess Board          /_\                      *
*                \_/      -------------------     \_/                      *
*                /_\            Cboard            /_\                      *
*                |_|      -------------------     |_|                      *
*               /___\      GNU GPL Version 2     /___\                     *
*                                                                          *
***************************************************************************/
/* Header Files */
#include "board.h"
/* Window */
static WINDOW *winF;
static WINDOW *winE;
/* File Open */
FILE *gnuchess;
/* Computer Move */
const char *cmove = ". ";
const char *emove = ". ... ";
/* Defintions */
Datum date;
Modul mode;
Colour colour;
/* Constructor */
Cboard::Cboard() {}

//-----------------------------------------------------------------------------

/* Display Chess Board */
void Cboard::displayBoard(char *chess, char *white, char *black)
{	
	/* Chess Board Array */
	char cb[11][11][2] = {
			
	{{' ',5},{'1',5},{'2',5},{'3',5},{'4',5},{'5',5},{'6',5},{'7',5},{'8',5},{' ',5},{0,0}},
	{{'h',5},{'R',3},{'P',4},{' ',3},{' ',4},{' ',1},{' ',2},{'P',1},{'R',2},{'h',5},{0,0}},
	{{'g',5},{'N',4},{'P',3},{' ',4},{' ',3},{' ',2},{' ',1},{'P',2},{'N',1},{'g',5},{0,0}},
	{{'f',5},{'B',3},{'P',4},{' ',3},{' ',4},{' ',1},{' ',2},{'P',1},{'B',2},{'f',5},{0,0}},
	{{'e',5},{'K',4},{'P',3},{' ',4},{' ',3},{' ',2},{' ',1},{'P',2},{'K',1},{'e',5},{0,0}},
	{{'d',5},{'Q',3},{'P',4},{' ',3},{' ',4},{' ',1},{' ',2},{'P',1},{'Q',2},{'d',5},{0,0}},
	{{'c',5},{'B',4},{'P',3},{' ',4},{' ',3},{' ',2},{' ',1},{'P',2},{'B',1},{'c',5},{0,0}},
	{{'b',5},{'N',3},{'P',4},{' ',3},{' ',4},{' ',1},{' ',2},{'P',1},{'N',2},{'b',5},{0,0}},
	{{'a',5},{'R',4},{'P',3},{' ',4},{' ',3},{' ',2},{' ',1},{'P',2},{'R',1},{'a',5},{0,0}},
	{{' ',5},{'1',5},{'2',5},{'3',5},{'4',5},{'5',5},{'6',5},{'7',5},{'8',5},{' ',5},{0,0}}};
	
	char eb[11][11][2] = {
			
	{{' ',5},{'8',5},{'7',5},{'6',5},{'5',5},{'4',5},{'3',5},{'2',5},{'1',5},{' ',5},{0,0}},
	{{'a',5},{' ',1},{' ',2},{' ',1},{' ',2},{' ',3},{' ',4},{' ',3},{' ',4},{'a',5},{0,0}},
	{{'b',5},{' ',2},{' ',1},{' ',2},{' ',1},{' ',4},{' ',3},{' ',4},{' ',3},{'b',5},{0,0}},
	{{'c',5},{' ',1},{' ',2},{' ',1},{' ',2},{' ',3},{' ',4},{' ',3},{' ',4},{'c',5},{0,0}},
	{{'d',5},{' ',2},{' ',1},{' ',2},{' ',1},{' ',4},{' ',3},{' ',4},{' ',3},{'d',5},{0,0}},
	{{'e',5},{' ',1},{' ',2},{' ',1},{' ',2},{' ',3},{' ',4},{' ',3},{' ',4},{'e',5},{0,0}},
	{{'f',5},{' ',2},{' ',1},{' ',2},{' ',1},{' ',4},{' ',3},{' ',4},{' ',3},{'f',5},{0,0}},
	{{'g',5},{' ',1},{' ',2},{' ',1},{' ',2},{' ',3},{' ',4},{' ',3},{' ',4},{'g',5},{0,0}},
	{{'h',5},{' ',2},{' ',1},{' ',2},{' ',1},{' ',4},{' ',3},{' ',4},{' ',3},{'h',5},{0,0}},
	{{' ',5},{'8',5},{'7',5},{'6',5},{'5',5},{'4',5},{'3',5},{'2',5},{'1',5},{' ',5},{0,0}}};
	
	//---------------------------------------------------------------------
	
	/* Black */
	eb[8][1][0] = 'R';
	eb[7][1][0] = 'N';
	eb[6][1][0] = 'B';
	eb[5][1][0] = 'K';
	eb[4][1][0] = 'Q';
	eb[3][1][0] = 'B';
	eb[2][1][0] = 'N';
	eb[1][1][0] = 'R'; 
	
	eb[8][2][0] = 'P'; 
	eb[7][2][0] = 'P';
	eb[6][2][0] = 'P';
	eb[5][2][0] = 'P';
	eb[4][2][0] = 'P';
	eb[3][2][0] = 'P';
	eb[2][2][0] = 'P';
	eb[1][2][0] = 'P'; 
		
	/* White */
	eb[8][7][0] = 'P'; 
	eb[7][7][0] = 'P';
	eb[6][7][0] = 'P';
	eb[5][7][0] = 'P';
	eb[4][7][0] = 'P';
	eb[3][7][0] = 'P';
	eb[2][7][0] = 'P';
	eb[1][7][0] = 'P';

	eb[8][8][0] = 'R';
	eb[7][8][0] = 'N';
	eb[6][8][0] = 'B';
	eb[5][8][0] = 'K';
	eb[4][8][0] = 'Q';
	eb[3][8][0] = 'B';
	eb[2][8][0] = 'N';
	eb[1][8][0] = 'R';
		
	//---------------------------------------------------------------------

	/* Date */
	strftime(mdate, 75, "%Y.%m.%d", date.date_Board());	
	/* Time and Round */
	wtime.time = 7200;
	btime.time = 7200;
	etime.numb = 0;
	etime.count = 2;
	etime.round = 0;
	etime.round++;
	/* Colors */
	colour.color_Board(); 
	/* While Loop */
	while(chess)
	{	
		//-------------------------------------------------------------

		/* Chess Board Core */
		short int x = 0;
		short int y = 0;
		short int z = 2;
		
		move(2,3);
		for(y = 0; y <= HIGH; ++y)
		{	
			move(++z,3);
			for(x = 0; x <= LOW; ++x)
			{	
				attrset(COLOR_PAIR(eb[x][y][1]));
				printw(" %c ", eb[x][y][0]);
			}
			printw("\n");
		}
		/* Bughouse */
		z = 2;
		move(2,47);
		for(y = 0; y <= HIGH; ++y)
		{	
			move(++z,47);
			for(x = 0; x <= LOW; ++x)
			{
				attrset(COLOR_PAIR(cb[x][y][1]));
				printw(" %c ", cb[x][y][0]);
			}
			printw("\n");
		}
		
		//-------------------------------------------------------------
		
		/* Player */
		etime.count++;
		if(etime.count % 2)
		{
			player[1] = true;
			player[8] = false;
		}
		else
		{
			player[1] = false;
			player[8] = true;
		}
		
		//-------------------------------------------------------------

		/* Window Box */
		attrset(use_default_colors());
		winF = newwin(11,76,13,2);
		box(winF,ACS_VLINE,ACS_HLINE);
		winE = newwin(9,74,14,3);
		scrollok(winE,true);
		/* File Open */
		gnuchess=fopen("/var/log/cboard/engine","r+");
		/* Computer */
		while(fread(position,1, sizeof(position),gnuchess))
		{	
			if(chess[2])
			{
				bmove = strstr(position,cmove);
				sscanf(bmove,". %s",nmove);
			}
			if(chess[1])
			{
				bmove = strstr(position,emove);
				sscanf(bmove,". ... %s",nmove);
			}
			wprintw(winE,"%s", position);
		}
		/* Windows Refresh */
		touchwin(stdscr);
		refresh();
		wrefresh(winF);
		wrefresh(winE);
		
		//-------------------------------------------------------------
		
		/* Time Control */
		etime.start=time(NULL);
		mode.tcpnetwork(nmove,chess,player);		
		etime.diff = difftime(etime.stop=time(NULL),etime.start);
		if(player[1])
		{		
			wtime.time -= etime.diff;
			wtime.horas = ((wtime.time / 60) / 60);
			wtime.minutes = ((wtime.time / 60) % 60);
			wtime.seconds = (wtime.time % 60);
		}
		else if(player[8])
		{
			btime.time -= etime.diff;
			btime.horas = ((btime.time / 60) / 60);
			btime.minutes = ((btime.time / 60) % 60);
			btime.seconds = (btime.time % 60);
		}

		//-------------------------------------------------------------
		
		/* a - h | 1 -8 */
		if((nmove[0] && nmove[2] >= 97) && 
		   (nmove[0] && nmove[2] <= 104) && 
		   (nmove[1] && nmove[3] >= 49) && 
		   (nmove[1] && nmove[3] <= 56))
		{	
			mov1.fxdecimal = mov2.fxdecimal = nmove[0];
			mov1.fydecimal = mov2.fydecimal = nmove[1];
			mov1.txdecimal = mov2.txdecimal = nmove[2];
			mov1.tydecimal = mov2.tydecimal = nmove[3];
		}
		else
		{
			/* Back to Menu */
			chess = 0;
		}
		
		//-------------------------------------------------------------
		
		/* Decimal White Board */
		mov1.fxmove = mov1.fxdecimal - 96;
		mov1.txmove = mov1.txdecimal - 96;
		mov1.fymove = 9 - (mov1.fydecimal - 48);	
		mov1.tymove = 9 - (mov1.tydecimal - 48);
		eb[mov1.txmove][mov1.tymove][0] = 
		eb[mov1.fxmove][mov1.fymove][0];
		eb[mov1.fxmove][mov1.fymove][0] = ' ';
		eb[mov1.txmove][mov1.tymove][1] = 
		eb[mov1.fxmove][mov1.fymove][1];
		/* Board Color */
		mov1.tzmove = mov1.txmove + mov1.tymove;
		/* Decimal Black Board */
		mov2.fxmove = 9 - (mov2.fxdecimal - 96);
		mov2.txmove = 9 - (mov2.txdecimal - 96);
		mov2.fymove = mov2.fydecimal - 48;	
		mov2.tymove = mov2.tydecimal - 48;
		cb[mov2.txmove][mov2.tymove][0] = 
		cb[mov2.fxmove][mov2.fymove][0];
		cb[mov2.fxmove][mov2.fymove][0] = ' '; 
		cb[mov2.txmove][mov2.tymove][1] = 
		cb[mov2.fxmove][mov2.fymove][1];

		/* Board Color */					
		if(mov1.tzmove % 2)
		{
			/* White Cyan */
			if(player[1]){
			eb[mov1.txmove][mov1.tymove][1] = 4;
			cb[mov2.txmove][mov2.tymove][1] = 4;}			
			/* Red Cyan */
			else if(player[8]){
			eb[mov1.txmove][mov1.tymove][1] = 2;
			cb[mov2.txmove][mov2.tymove][1] = 2;}
		}
		else
		{
			/* White Blue */
			if(player[1]){
			eb[mov1.txmove][mov1.tymove][1] = 3;
			cb[mov2.txmove][mov2.tymove][1] = 3;}
			/* Red Blue */
			else if(player[8]){
			eb[mov1.txmove][mov1.tymove][1] = 1;
			cb[mov2.txmove][mov2.tymove][1] = 1;}
		}

		//-------------------------------------------------------------

		/* Show Move Message */
		mvhline(0,0,ACS_HLINE,100);
		mvhline(2,0,ACS_HLINE,100);
		move(1,1);

		if(player[1])
		{
			++etime.numb;
			printw(" %2d.%c%c",
			etime.numb, mov1.fxdecimal, mov1.fydecimal);
			printw("/%c%c ",mov1.txdecimal, mov1.tydecimal);
			printw("\t\t %02d:%02d:%02d",
			wtime.horas, wtime.minutes, wtime.seconds);
			printw("\t\t%s", white);
		}
		else if(player[8])
		{
			printw(" %2d.%c%c",
			etime.numb, mov1.fxdecimal, mov1.fydecimal);
			printw("/%c%c ",mov1.txdecimal, mov1.tydecimal);
			printw("\t\t %02d:%02d:%02d",
			btime.horas, btime.minutes, btime.seconds);
			printw("\t\t%s", black);
		}
	}
	/* File Closed */
	fclose(gnuchess);
	endwin();
	clear();
}

//-----------------------------------------------------------------------------

