/***************************************************************************
*                 _                                _                       *
*                /_\         Chess Board          /_\                      *
*                \_/      -------------------     \_/                      *
*                /_\            Cboard            /_\                      *
*                |_|      -------------------     |_|                      *
*               /___\      GNU GPL Version 2     /___\                     *
*                                                                          *
***************************************************************************/
#ifndef BOARD_H_
#define BOARD_H_
/* Header Files */
#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <ctime>
#include <curses.h>
#include "cbtime.h"
#include "colour.h"
#include "move.h"
/* Define Array */
#define HIGH 9
#define LOW 9
/* Define Buffer */
#define MOV 16
#define BUF 2048
/* Define Char */
#define C 10
/* Define Date */
#define DATE 75

//-----------------------------------------------------------------------------

class Cboard
{	
public:	
	/* Move */
	char mdate[DATE];
	char nmove[MOV];
	char position[BUF];
	char *bmove;
	/* Player */
	char player[C];

	/* Class Engine */
	struct uciEngine
	{
		/* Time */
		signed int time;
		short int round;
		short int numb;
		short int count;
		/* Clock */
		double diff;
		short int horas;
		short int minutes; 
		short int seconds;
		time_t start;
		time_t stop;
	}etime, wtime, btime;

//-----------------------------------------------------------------------------

	/* Class Move */
	struct uciMove
	{
		/* Move */
		char fxdecimal;
		char fydecimal;
		char txdecimal;
		char tydecimal;
		short int fxmove;
		short int txmove;
		short int fymove;
		short int tymove;
		short int tzmove;
	}mov1, mov2;

//-----------------------------------------------------------------------------

	Cboard();
	void displayBoard(char *chess, char *white, char *black);
};

//-----------------------------------------------------------------------------

#endif


